/*
 * Board.java
 *
 * Created on 9. listopad 2006, 19:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package uloha2;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Date;
import java.util.Random;

/**
 *
 * @author zelial
 */
public class Board {
    private int[][] board = new int[3][3];
    //spravne souradnice konkretni cislice ( napr petka ma byt na [correctRow[5],correctCol[5]]...)
    private static final int[] correctRow = {1,0,0,0,1,2,2,2,1}; 
    private static final int[] correctCol = {1,0,1,2,2,2,1,0,0};
    private String comment = new String();
    /** Creates a new instance of Board */
    public Board() {
        //inicializujem hraci pole
        for (int i=0;i<9;i++){
            board[i%3][i/3] = 0;
        }
        ArrayList<Integer> l = new ArrayList<Integer>();
        for (int i=1;i<9;i++){
            l.add(new Integer(i));
        }
        Random rnd = new Random(new Date().getTime());
        //cyklime dokud neni pole l prazdne = nemame rozdeleny vsechny prvky
        //teoreticky nekonecne dlouhy cyklus :)
        while (! l.isEmpty()){
            int souradnice = Math.abs(rnd.nextInt() % 9);
            if (board[souradnice%3][souradnice/3] == 0){
                board[souradnice%3][souradnice/3] = l.get(0).intValue();
                l.remove(0);
            }
        }
    }
    /** Creates a new instance of Board - copy constructor */
    public Board(Board b) {
        for (int i=0;i<9;i++){
            board[i%3][i/3] = b.getAt(i%3,i/3);
        }
        comment = b.getComment();
    }
    //vraci hodnoceni pozice dlel heuristiky chybne umisteni
    public int getHeurChyba(){
        int pocetChybnych = 0;
        for (int i=1;i<9;i++){
            if (board[correctRow[i]][correctCol[i]] != i){
                ++pocetChybnych;
            }
        }
        return pocetChybnych;
    }
    //vraci hodnoceni pozice dle heuristiky manhattanska vzdalenost
    public int getHeurManhattan() throws Exception{
        int vzdalenost = 0;
        for (int i=1;i<9;i++){
            int step = Math.abs(correctRow[i]-getRow(i))+Math.abs(correctCol[i]-getCol(i));
            vzdalenost += step;
            //System.out.println(i+" ~ "+step);
            }
        return vzdalenost;
    }
    public int getAt(int row,int col){
        return board[row][col];
    }
    private void setAt(int row,int col,int value){
        board[row][col] = value;
    }
    //posune ctverecek pod prazdnym polem nahoru
    //vraci false pri neuspechu, jinak true
    public boolean moveUp() throws Exception{
        int emptyRow,emptyCol;
        emptyRow = getRow(0);
        emptyCol = getCol(0);
        if (emptyRow != 2){
            setAt(emptyRow,emptyCol,getAt(emptyRow+1,emptyCol));
            setAt(emptyRow+1,emptyCol,0);
            return true;
        }else{
            return false;
        }
    }
    //posune ctverecek nad prazdnym polem dolu
    //vraci false pri neuspechu, jinak true
    public boolean moveDown() throws Exception{
        int emptyRow,emptyCol;
        emptyRow = getRow(0);
        emptyCol = getCol(0);
        if (emptyRow != 0){
            setAt(emptyRow,emptyCol,getAt(emptyRow-1,emptyCol));
            setAt(emptyRow-1,emptyCol,0);
            return true;
        }else{
            return false;
        }
    }
    //posune ctverecek vlevo od prazdneho pole doprava
    //vraci false pri neuspechu, jinak true
    public boolean moveRight() throws Exception{
        int emptyRow,emptyCol;
        emptyRow = getRow(0);
        emptyCol = getCol(0);
        if (emptyCol != 0){
            setAt(emptyRow,emptyCol,getAt(emptyRow,emptyCol-1));
            setAt(emptyRow,emptyCol-1,0);
            return true;
        }else{
            return false;
        }
    }
//posune ctverecek vpravo od prazdneho pole doleva
    //vraci false pri neuspechu, jinak true
    public boolean moveLeft() throws Exception{
        int emptyRow,emptyCol;
        emptyRow = getRow(0);
        emptyCol = getCol(0);
        if (emptyCol != 2){
            setAt(emptyRow,emptyCol,getAt(emptyRow,emptyCol+1));
            setAt(emptyRow,emptyCol+1,0);
            return true;
        }else{
            return false;
        }
    }
    //vraci radek, kde je dane cislo
    public int getRow(int cislo) throws Exception {
        for (int i=0;i<9;i++){
            if (board[i%3][i/3] == cislo)
                return i%3;
        } 
        throw new Exception("v poli neni nulovy ctverecek");
    }
    //vraci sloupek, kde je dane cislo
    public int getCol(int cislo)throws Exception{
        for (int i=0;i<9;i++){
            if (board[i%3][i/3] == cislo)
                return i/3;
        }
        throw new Exception("v poli neni nulovy ctverecek");
    }
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append(board[0][0]).append("|").append(board[0][1]).append("|").append(board[0][2]).append("\n");
        sb.append("-+-+-\n");
        sb.append(board[1][0]).append("|").append(board[1][1]).append("|").append(board[1][2]).append("\n");
        sb.append("-+-+-\n");
        sb.append(board[2][0]).append("|").append(board[2][1]).append("|").append(board[2][2]).append("\n");
        return sb.toString();
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }
    
    
}
